PImage chicago;
Table Station;

color[] backstage = {
  #ffffcc, #a1dab4, #41b6c4, #2c7fb8, #253494, #000000
}; //light to dark/0-5
color[] palette = backstage;

MercatorMap mercatorMap;

PVector bouy;
PVector bouy2;
PVector bouy3;

String stations[];
String stations2[];
String stations3[];

String test[];
String test2[];
String test3[];

String src = "http://www.ndbc.noaa.gov/data/realtime2/CHII2.txt"; //bouy one
String src2 = "http://www.ndbc.noaa.gov/data/realtime2/CNII2.txt"; //bouy two 41.85 -87.60
String src3 = "http://www.ndbc.noaa.gov/data/realtime2/FSTI2.txt"; //bouy three 41.97 -87.64

float angle = 45;

float bouyX = 125;
float bouyY = 220;

//compass
float movement;
 
float needlePin;
float needleA;
float needleB;
 
float compassBodyX;
float compassBodyY;
float bodySize;
 
float compassInner;
 
float compassRingX;
float compassRingY;
float ringSize;
 
float leftNeedleX;
float leftNeedleY;
float topNeedleX;
float topNeedleY;
float rightNeedleX;
float rightNeedleY;
float bottomNeedleX;
float bottomNeedleY;
 
float needlePinX;
float needlePinY;
float pinSizeX;
float pinSizeY;
 
float centerPin=400;



void setup() {
  size(400, 516); //actual size of image
  smooth();
  frameRate(30);
  stroke(100);
  strokeWeight(15);
  
   leftNeedleX=380;
  leftNeedleY=400;
  topNeedleX=400;
  topNeedleY=150;
  rightNeedleX=420;
  rightNeedleY=400;
  bottomNeedleX=400;
  bottomNeedleY=650;
 
  compassBodyX=400;
  compassBodyY=400;
  bodySize=680;
 
  compassInner=400;
 
  compassRingX=400;
  compassRingY=50;
  ringSize=80;
   
  needlePinX=400;
  needlePinY=400;
  pinSizeX=30;
  pinSizeY=30;
 
 
  background (70, 240, 239);
  smooth();
 
  //ring on top
  noFill();
  ellipse(compassRingX, compassRingY, ringSize, ringSize);
   
   
  stations = loadStrings(src);
  stations2 = loadStrings(src2);
  stations3 = loadStrings(src3);
  
  chicago = loadImage("chicago.png");

  mercatorMap= new MercatorMap(400, 516, 42.04, 41.63, -87.92, -87.49);//screen width, screen height, top, bottom, left, right

  test = split(stations[2], ' ');
  println("year:" + test[0]);  //YEAR
  println("MONTH:" + test[1]);  //MONTH
  println("DAY:" + test[2]);  //DAY
  println("HOUR:" + test[3]);  //HOUR
  println("MIUNTE:" + test[4]);  // MIUNTE
  println("WDIR:" + test[5]);  //WDIR * 
  println("WSPD:" + test[7]);  //WSPD *
  println("WGST:" + test[9]);  //WGST *
 
  test2 = split(stations[2], ' ');
  println("year:" + test2[0]);  //YEAR
  println("MONTH:" + test2[1]);  //MONTH
  println("DAY:" + test2[2]);  //DAY
  println("HOUR:" + test2[3]);  //HOUR
  println("MIUNTE:" + test2[4]);  // MIUNTE
  println("WDIR:" + test2[5]);  //WDIR * 
  println("WSPD:" + test2[7]);  //WSPD *
  println("WGST:" + test2[9]);  //WGST *

  test3 = split(stations[3], ' ');
  println("year:" + test3[0]);  //YEAR
  println("MONTH:" + test3[1]);  //MONTH
  println("DAY:" + test3[2]);  //DAY
  println("HOUR:" + test3[3]);  //HOUR
  println("MIUNTE:" + test3[4]);  // MIUNTE
  println("WDIR:" + test3[5]);  //WDIR * 
  println("WSPD:" + test3[7]);  //WSPD *
  println("WGST:" + test3[9]);  //WGST *
}


void draw() {
  image(chicago, 0, 0, width, height);
  smooth();
  
  //compass body
  fill (palette[5],50); 
  strokeWeight (10);
  ellipseMode (CENTER);
  ellipse (72, 72, 100, 100); //position //size
   
  //inner circle
  strokeWeight (5);
  noFill();
  ellipse (72,72, 50,50);
//  ellipse (compassInner,compassInner,compassInner,compassInner);
 
  //north, south, east, west
  textSize(10);
  fill(200, 0, 50);
  text("N", 70, 30);
  fill(0, 102, 153, 151);
//  text("W", 20, 172);
//  text("E", 670, 400);
//  text("S", 388, 70);
   
 // needles of compass
  strokeWeight (5);
  fill (200, 0, 0);
  triangle (leftNeedleX, leftNeedleY, topNeedleX, topNeedleY, leftNeedleX+40, leftNeedleY);
  fill (50);
  triangle (leftNeedleX, leftNeedleY, bottomNeedleX, bottomNeedleY, leftNeedleX+40, leftNeedleY);
     
  //center pin
  fill (palette[0],100);
  ellipseMode(CENTER);
  ellipse(72,72,100,100);

   
//  float distance=random(-3,3);
//  constrain(topNeedleX,380,420);
//  constrain(bottomNeedleX,380,420);
//  topNeedleX=topNeedleX+distance;
//  bottomNeedleX = bottomNeedleX-distance;
  
  
  String src = "http://www.ndbc.noaa.gov/data/realtime2/CHII2.txt"; //bouy one
  String src2 = "http://www.ndbc.noaa.gov/data/realtime2/CNII2.txt"; //bouy two 41.85 -87.60
  String src3 = "http://www.ndbc.noaa.gov/data/realtime2/FSTI2.txt"; //bouy three 41.97 -87.64


  //bouy one
  float lat = 41.91;
  float lon = -87.57;
  noStroke();
  bouy = mercatorMap.getScreenLocation(new PVector(lat, lon));

  //wind direction ellipses
  if (!test[5].equals("")) {
    String wdir = test[5];
    float Wdir = new Float(test[5]);

    ellipse(bouy.x, bouy.y, Wdir/5, Wdir/5);
    if (dist(mouseX, mouseY, bouy.x, bouy.y) < 99) {
      textSize(20);
      fill(palette[4]);
      text("wind direction:" + wdir, 20, 430);
    }
  }

  if (!test[6].equals("")) {
    String wdir = test[6];
    float Wdir = new Float(test[6]);
    fill(palette[4]);
    ellipse(bouy.x, bouy.y, Wdir/5, Wdir/5);
    if (dist(mouseX, mouseY, bouy.x, bouy.y) > 99) {
      textSize(20);
      fill(palette[3]);
      text("wind direction:" + wdir, 20, 430);
    }
  }

  //wind gust ellipse
  if (!test[9].equals("")) {
    String wgst = test[9];
    float Wgst = new Float(test[9]);

    ellipse(bouy.x, bouy.y, Wgst*10, Wgst*10);
    if (dist(mouseX, mouseY, bouy.x, bouy.y) < 30) {
      textSize(20);
      fill(palette[2]);
      text("wind gust:" + wgst, 20, 450);
    }
  }

  if (!test[10].equals("")) {
    String wgst = test[10];
    float Wgst = new Float(test[10]);
    fill(palette[1]);
    ellipse(bouy.x, bouy.y, Wgst*10, Wgst*10);
    if (dist(mouseX, mouseY, bouy.x, bouy.y) > 30) {
      textSize(20);
      fill(palette[1]);
      text("wind gust:" + wgst, 20, 450);
    }
  }

  //wind speed ellipses
  if (!test[7].equals("")) {
    String wspd = test[7];
    float Wspd = new Float(test[7]);
    pushStyle();
    if (Wspd < 3) {
      // println(wspd);
      fill(palette[2]);
    }
    if (Wspd > 3) {
      fill(palette[2]);
    }
    ellipse(bouy.x, bouy.y, Wspd*2, Wspd*2);
    popStyle();
    if (dist(mouseX, mouseY, bouy.x, bouy.y) < 30) {
      textSize(20);
      text("wind speed:" + wspd, 20, 470);
    }
  }

  if (!test[8].equals("")) {
    String wspd = test[8];
    float Wspd = new Float(test[8]);
    pushStyle();
    println(Wspd);
    if (Wspd < 3) {
      fill(palette[2]);
    }
    if (Wspd > 3) {
      fill(palette[3]);
    }
    ellipse(bouy.x, bouy.y, Wspd*2, Wspd*2);
    popStyle();
    if (dist(mouseX, mouseY, bouy.x, bouy.y) < 30) {
      textSize(20);
      text("wind speed:" + wspd, 20, 470);
    }
  }

  //location ellipse
  pushStyle();
  fill(250, 255, 0); 
  ellipse(bouy.x, bouy.y, 5, 5);
  popStyle();

  
  
  //
  float x = bouyX + cos(radians(angle))*120;
  float y = bouyY + sin(radians(angle))*120;

  strokeWeight (3);
  line(bouyX, bouyY, x, y);

  ellipse(bouyX, bouyY, 10, 10);


//bouy two
float lat2 = 41.85; //bouy two location
float lon2 = -87.60; // bouy two location

  noStroke();
  bouy2 = mercatorMap.getScreenLocation(new PVector(lat2, lon2));

  //wind direction ellipses
  if (!test2[5].equals("")) {
    String wdir2 = test2[5];
    float Wdir2 = new Float(test2[5]);

    ellipse(bouy2.x, bouy2.y, Wdir2/5, Wdir2/5);
    if (dist(mouseX, mouseY, bouy2.x, bouy2.y) < 99) {
      textSize(20);
      fill(palette[4]);
      text("wind direction:" + wdir2, 20, 430);
    }
  }

  if (!test2[6].equals("")) {
    String wdir2 = test2[6];
    float Wdir2 = new Float(test2[6]);
    fill(palette[4]);
    ellipse(bouy2.x, bouy2.y, Wdir2/5, Wdir2/5);
    if (dist(mouseX, mouseY, bouy2.x, bouy2.y) > 99) {
      textSize(20);
      fill(palette[3]);
      text("wind direction:" + wdir2, 20, 430);
    }
  }

  //wind gust ellipse
  if (!test2[9].equals("")) {
    String wgst2 = test2[9];
    float Wgst2 = new Float(test2[9]);

    ellipse(bouy2.x, bouy2.y, Wgst2*10, Wgst2*10);
    if (dist(mouseX, mouseY, bouy2.x, bouy2.y) < 30) {
      textSize(20);
      fill(palette[2]);
      text("wind gust:" + wgst2, 20, 450);
    }
  }

  if (!test2[10].equals("")) {
    String wgst2 = test2[10];
    float Wgst2 = new Float(test2[10]);
    fill(palette[1]);
    ellipse(bouy2.x, bouy2.y, Wgst2*10, Wgst2*10);
    if (dist(mouseX, mouseY, bouy2.x, bouy2.y) > 30) {
      textSize(20);
      fill(palette[1]);
      text("wind gust:" + wgst2, 20, 450);
    }
  }

  //wind speed ellipses
  if (!test2[7].equals("")) {
    String wspd2 = test2[7];
    float Wspd2 = new Float(test2[7]);
    pushStyle();
    if (Wspd2 < 3) {
      // println(wspd);
      fill(palette[2]);
    }
    if (Wspd2 > 3) {
      fill(palette[2]);
    }
    ellipse(bouy2.x, bouy2.y, Wspd2*2, Wspd2*2);
    popStyle();
    if (dist(mouseX, mouseY, bouy2.x, bouy2.y) < 30) {
      textSize(20);
      text("wind speed:" + wspd2, 20, 470);
    }
  }

  if (!test2[8].equals("")) {
    String wspd2 = test2[8];
    float Wspd2 = new Float(test2[8]);
    pushStyle();
    println(Wspd2);
    if (Wspd2 < 3) {
      fill(palette[2]);
    }
    if (Wspd2 > 3) {
      fill(palette[3]);
    }
    ellipse(bouy2.x, bouy2.y, Wspd2*2, Wspd2*2);
    popStyle();
    if (dist(mouseX, mouseY, bouy2.x, bouy2.y) < 30) {
      textSize(20);
      text("wind speed:" + wspd2, 20, 470);
    }
  }

//location ellipse
  pushStyle();
  fill(250, 255, 0); 
  ellipse(bouy2.x, bouy2.y, 5, 5);
  popStyle();



  //bouy three
  float lat3 = 41.97;
  float lon3 = -87.64;
  noStroke();
  bouy3 = mercatorMap.getScreenLocation(new PVector(lat3, lon3));

  //wind direction ellipses
  if (!test3[5].equals("")) {
    String wdir3 = test3[5];
    float Wdir3 = new Float(test3[5]);

    ellipse(bouy3.x, bouy3.y, Wdir3/5, Wdir3/5);
    if (dist(mouseX, mouseY, bouy3.x, bouy3.y) < 99) {
      textSize(20);
      fill(palette[4]);
      text("wind direction:" + wdir3, 20, 430);
    }
  }

  if (!test3[6].equals("")) {
    String wdir3 = test3[6];
    float Wdir3 = new Float(test3[6]);
    fill(palette[4]);
    ellipse(bouy3.x, bouy3.y, Wdir3/5, Wdir3/5);
    if (dist(mouseX, mouseY, bouy3.x, bouy3.y) > 99) {
      textSize(20);
      fill(palette[3]);
      text("wind direction:" + wdir3, 20, 430);
    }
  }

  //wind gust ellipse
  if (!test3[9].equals("")) {
    String wgst3 = test3[9];
    float Wgst3 = new Float(test3[9]);

    ellipse(bouy3.x, bouy3.y, Wgst3*10, Wgst3*10);
    if (dist(mouseX, mouseY, bouy3.x, bouy3.y) < 30) {
      textSize(20);
      fill(palette[2]);
      text("wind gust:" + wgst3, 20, 450);
    }
  }

  if (!test3[10].equals("")) {
    String wgst3 = test3[10];
    float Wgst3 = new Float(test3[10]);
    fill(palette[1]);
    ellipse(bouy3.x, bouy3.y, Wgst3*10, Wgst3*10);
    if (dist(mouseX, mouseY, bouy3.x, bouy3.y) > 30) {
      textSize(20);
      fill(palette[1]);
      text("wind gust:" + wgst3, 20, 450);
    }
  }

  //wind speed ellipses
  if (!test3[7].equals("")) {
    String wspd3 = test3[7];
    float Wspd3 = new Float(test3[7]);
    pushStyle();
    if (Wspd3 < 3) {
      // println(wspd);
      fill(palette[2]);
    }
    if (Wspd3 > 3) {
      fill(palette[2]);
    }
    ellipse(bouy3.x, bouy3.y, Wspd3*2, Wspd3*2);
    popStyle();
    if (dist(mouseX, mouseY, bouy3.x, bouy3.y) < 30) {
      textSize(20);
      text("wind speed:" + wspd3, 20, 470);
    }
  }

  if (!test3[8].equals("")) {
    String wspd3 = test3[8];
    float Wspd3 = new Float(test3[8]);
    pushStyle();
    println(Wspd3);
    if (Wspd3 < 3) {
      fill(palette[2]);
    }
    if (Wspd3 > 3) {
      fill(palette[3]); //**
    }
    ellipse(bouy3.x, bouy3.y, Wspd3*2, Wspd3*2);
    popStyle();
    if (dist(mouseX, mouseY, bouy3.x, bouy3.y) < 30) {
      textSize(20);
      text("wind speed:" + wspd3, 20, 470);
    }
  }
//location ellipse
  pushStyle();
  fill(250, 255, 0); 
  ellipse(bouy3.x, bouy3.y, 5, 5);
  popStyle();







}


